module Locators
  class TestPage

    # All the Locators in the initialize block need to be declared here for read write permission.
    attr_accessor :EMAIL_TEXTBOX
    attr_accessor :PASSWORD_TEXTBOX
    attr_accessor :LOGIN_LINK
    attr_accessor :LOGIN_BUTTON
    attr_accessor :SUBMIT_BUTTON

    def initialize

      # Locators can be declared here by mentioning {how?(xpath,css,id) and what?(identifier)}
      @EMAIL_TEXTBOX = Locator.new(:id, "")
      @PASSWORD_TEXTBOX = Locator.new(:xpath, "")
      @LOGIN_LINK = Locator.new(:link, "Login")
      @LOGIN_BUTTON = Locator.new(:css, "")
      @SUBMIT_BUTTON = Locator.new(:css, "")
    end

    # Dynamic locators can be declared here as a seperate method (This method doesnot need to be declared with attr_accessor)
    def LOGIN_DYNAMIC(variable)
      @LOGIN_DYNAMIC = Locator.new(:xpath,"//*[text()=#{variable}]")
    end

  end
end
