require 'robotest'
require 'require_all'
require 'allure-rspec'
require 'pathname'
require 'fileutils'
require 'headless'
require 'os'
require "pry"
require_rel "../locators/"
require_rel "../libraries/"
require_rel "../pages/"
require "time"
require "fileutils"
require 'uri'
require 'active_support/time'
require 'parseconfig'
include RoboTest

$conf = File.exist?('_robotest.yml') ? YAML.load_file('_robotest.yml') : raise "yaml file needs to be given as a input parameter"
FileUtils.mkdir_p("#{Pathname.pwd}/#{$conf['screenshot_location']}")
$browser = $conf['browser']

if OS.mac?
    $conf["switches"].delete("headless") if $conf["switches"]
end

RSpec.configure do |config|
    config.filter_run_when_matching :focus
    config.example_status_persistence_file_path = "reports/examples.txt"
    config.include AllureRSpec::Adaptor
end

AllureRSpec.configure do |config|
    config.output_dir = "reports/allure"
    config.clean_dir = true
    config.logging_level = Logger::WARN
end

RSpec.configure do |c|
  
  # To take screen shots of all the drivers when there is a failure
  c.after(:each) do |example|
    unless example.exception.nil?
        begin
            drivers = Driver.get_all_drivers
            drivers.each do |l,m|
              example.attach_file(m,l.save_screenshot)
            end
        rescue Exception => e
            puts example.message
            puts example.backtrace
        end
    end
    puts "Runs after each in spec helper"
  end
  
  # To quit all the drivers after all the test cases are run.
  c.after(:all) do |example|
    Driver.quit_all_drivers
    puts "Runs after all in spec helper"
  end

  # steps to be added which has to be run before all block (Common throughout the project)
  c.before(:all) do |example|
    puts "Runs before all in spec helper"
  end
  
  # steps to be added which has to be run before each block (Common throughout the project)
  c.before(:each) do |example|
    puts "#{example.metadata[:example_group][:description]} - #{example.metadata[:description]} - Started"
    puts "Runs before each in spec helper"
  end

  # Following is the order in which the before and after blocks are run
      # Runs before all in spec helper
      # Runs before all in spec
      # Runs before each in spec helper
      # Runs before each in spec
      # Runs after each in spec
      # Runs after each in spec helper
      # Runs after all in spec
      # Runs after all in spec helper
end

