module RoboTest
  class MultiLocator

    attr_accessor :how
    attr_accessor :what
    attr_accessor :options

    def initialize(
        how,
        what,
        options = {
          "hidden" => false,
          "ajax_load" => false
        }
      )
      @how = how
      @what = what
      @options = options
    end

    def options(driver = $focus_driver)
      @options
    end

    def text(driver = $focus_driver)
      element_list = driver.find_elements(self)
      return element_list.map{ |n| n.text }
    end

    def count(driver = $focus_driver)
      element_list = driver.find_elements(self)
      return element_list.count
    end

    def attribute(name, driver = $focus_driver)
      element_list = driver.find_elements(self)
      return element_list.map{ |n| n.attribute(name) }
    end

    def is_present?(driver=$focus_driver)
      driver.driver.manage.timeouts.implicit_wait = 0
      begin
        element_list = driver.driver.find_elements(self.how,self.what)
        return element_list.map{ |n| n.displayed? }
      rescue Exception => e
        driver.driver.manage.timeouts.implicit_wait = $conf["implicit_wait"]
        return false
      ensure
        driver.driver.manage.timeouts.implicit_wait = $conf["implicit_wait"]
      end
    end

    def is_present_with_wait?(timeout=$conf["implicit_wait"],driver=$focus_driver)   
      Wait.wait_for_element(self,timeout,driver)
      is_present?(driver)
    end

    def is_not_present_with_wait?(timeout=$conf["implicit_wait"],driver=$focus_driver)
      Wait.wait_for_element_hide(self,timeout,driver)
      return is_present?(driver).map{ |q| !q }
    end

    def to_s
      return "How ===> #{@how}\nWhat ===> #{@what}\nOptions ===> #{@options}"
    end

    def displayed?(driver = $focus_driver)
      element_list = driver.find_elements(self)
      return element_list.map{ |n| n.displayed? }
    end

    def enabled?(driver = $focus_driver)
      element_list = driver.find_elements(self)
      return element_list.map{ |n| n.enabled? }
    end

    def get_elements(driver = $focus_driver)
      driver.find_elements(self)
    end

  end
end
